/*
 * Camel ApiMethod Enumeration generated by camel-api-component-maven-plugin
 * Generated on: Wed Oct 23 03:56:56 UTC 2019
 */
package org.apache.camel.component.fhir.internal;

import java.lang.reflect.Method;
import java.util.List;

import org.apache.camel.component.fhir.api.FhirOperation;

import org.apache.camel.util.component.ApiMethod;
import org.apache.camel.util.component.ApiMethodArg;
import org.apache.camel.util.component.ApiMethodImpl;

import static org.apache.camel.util.component.ApiMethodArg.arg;

/**
 * Camel {@link ApiMethod} Enumeration for org.apache.camel.component.fhir.api.FhirOperation
 */
public enum FhirOperationApiMethod implements ApiMethod {

    ONINSTANCE(
        org.hl7.fhir.instance.model.api.IBaseResource.class,
        "onInstance",
        arg("id", org.hl7.fhir.instance.model.api.IIdType.class),
        arg("name", String.class),
        arg("parameters", org.hl7.fhir.instance.model.api.IBaseParameters.class),
        arg("outputParameterType", Class.class),
        arg("useHttpGet", boolean.class),
        arg("returnType", Class.class),
        arg("extraParameters", java.util.Map.class)),
    ONINSTANCEVERSION(
        org.hl7.fhir.instance.model.api.IBaseResource.class,
        "onInstanceVersion",
        arg("id", org.hl7.fhir.instance.model.api.IIdType.class),
        arg("name", String.class),
        arg("parameters", org.hl7.fhir.instance.model.api.IBaseParameters.class),
        arg("outputParameterType", Class.class),
        arg("useHttpGet", boolean.class),
        arg("returnType", Class.class),
        arg("extraParameters", java.util.Map.class)),
    ONSERVER(
        org.hl7.fhir.instance.model.api.IBaseResource.class,
        "onServer",
        arg("name", String.class),
        arg("parameters", org.hl7.fhir.instance.model.api.IBaseParameters.class),
        arg("outputParameterType", Class.class),
        arg("useHttpGet", boolean.class),
        arg("returnType", Class.class),
        arg("extraParameters", java.util.Map.class)),
    ONTYPE(
        org.hl7.fhir.instance.model.api.IBaseResource.class,
        "onType",
        arg("resourceType", Class.class),
        arg("name", String.class),
        arg("parameters", org.hl7.fhir.instance.model.api.IBaseParameters.class),
        arg("outputParameterType", Class.class),
        arg("useHttpGet", boolean.class),
        arg("returnType", Class.class),
        arg("extraParameters", java.util.Map.class)),
    PROCESSMESSAGE(
        org.hl7.fhir.instance.model.api.IBaseBundle.class,
        "processMessage",
        arg("respondToUri", String.class),
        arg("msgBundle", org.hl7.fhir.instance.model.api.IBaseBundle.class),
        arg("asynchronous", boolean.class),
        arg("responseClass", Class.class),
        arg("extraParameters", java.util.Map.class));
    

    private final ApiMethod apiMethod;

    private FhirOperationApiMethod(Class<?> resultType, String name, ApiMethodArg... args) {
        this.apiMethod = new ApiMethodImpl(FhirOperation.class, resultType, name, args);
    }

    @Override
    public String getName() { return apiMethod.getName(); }

    @Override
    public Class<?> getResultType() { return apiMethod.getResultType(); }

    @Override
    public List<String> getArgNames() { return apiMethod.getArgNames(); }

    @Override
    public List<Class<?>> getArgTypes() { return apiMethod.getArgTypes(); }

    @Override
    public Method getMethod() { return apiMethod.getMethod(); }
}
